/*
 * Copyright (c) 2006, 2007, 2009 Freescale Semiconductor, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#ifndef __CANSTACK_H__
#define __CANSTACK_H__

/*
 * Exported canstack interface.
 */
struct canpacket {
	unsigned int id;
	unsigned char len;
	unsigned char flags;
	unsigned char pad[2];
	unsigned char data[8];
};

#define CAN_FLAG_DEFAULT	0x00
#define CAN_FLAG_EXTENDED	0x01
#define CAN_FLAG_RTR		0x02

#define CAN_PACKET_STD_MASK	0x7ff
#define CAN_PACKET_EXTD_MASK	0x1fffffff

/*
 * Interface to canstack as seen from below (from candriver)
 */
int canstack_txpending(void);
void canstack_dequeue_txpacket(struct canpacket *cp);
int canstack_queue_rxpacket(struct canpacket *cp);

/*
 * Interface to canstack as seen from above (from btcs)
 */
void canstack_init(void);
int canstack_read_byte(void);
int canstack_write_byte(unsigned char b);
int canstack_write_bytes(unsigned char *, int);

#endif	/* !__CANSTACK_H__ */
